// This program is copyright VUW.
// You may not distribute it in any way without permission.

/* Code for COMP102 - 2019T2, Mid-Term Test 2
 * Name:
 * Username:
 * ID:
 */

import ecs100.*;
import java.util.ArrayList;
import java.util.Scanner;
import java.io.File;

/**
 * Question 2. Files                                [8 marks]
 * 
 * Suppose a file contains a sequence of numbers. Complete the
 * printMultiples(...) method below so that it will find and
 * print all the numbers in a file that are multiples of the
 * parameter provided to the method.
 * 
 * Hint: You will need to use the % operator.
 * 
 * For example, the file q2data.txt contains:
 *      12 7 9 43 18 10 20 16 49 24
 *      
 * printMultiples(3, ”q2data.txt”) should print out
 *      12.0 9.0 18.0 24.0
 *      
 * but printMultiples(4, ”q2data.txt”) should print out
 *      12.0 20.0 16.0 24.0
 *      
 * The method readAllNumbers(...) is done for you. You can call
 * it to read all the numbers in a file into an ArrayList.
 */
public class Program2
{
    public void printMultiples(int base, String filename){
        /*# YOUR CODE HERE */
        ArrayList<Double> nums = readAllNumbers(filename);
        for(double n : nums) {
            if( n % base == 0 ){
                UI.print(n + " ");
            }
        }
        /*# END OF YOUR CODE */
    }
 
    /**
     * Reads the given file and stores all the numbers in a list.
     */
    public ArrayList <Double> readAllNumbers(String filename){
        ArrayList <Double> nums = new ArrayList<Double>();
        try{
            Scanner scan = new Scanner(new File(filename));
            while (scan.hasNextDouble()){
                nums.add(scan.nextDouble());
            }
            scan.close();
        }
        catch(Exception e) {UI. println ("File error");}
        return nums;
    }
    
    /**
     * Prompts the user for a file and number, and then calls
     * printMultiples using those values.
     */
    public void run(){
        String filename = UIFileChooser.open();
        int base = UI.askInt("What is the base?");
        printMultiples(base, filename);
    }
    
    /*********************************************
     * YOU CAN IGNORE EVERYTHING BELOW THIS LINE *
     *********************************************/
    public void setupGUI() {
        UI.initialise();
        UI.addButton("Run", this::run);
        UI.setWindowSize(500,500);
        UI.setDivider(1.0);
    }
    
    public static void main(String[] args) {
        new Program2().setupGUI();
    }
}
