// This program is copyright VUW.
// You may not distribute it in any way without permission.

/* Code for COMP102 - 2019T2, Mid-Term Test 2
 * Name:
 * Username:
 * ID:
 */

import ecs100.*;
import java.util.ArrayList;
import java.util.Scanner;
import java.io.File;

/**
 * Question 3. Defining Classes                   [16 marks]
 * 
 * This question is about a program that will draw a sheep on the graphics pane. 
 * 
 * (a) [10 marks] Design a Sheep class to represent Sheep objects. 
 * 
 *  A sheep is represented on the screen by two ovals, and two sticks (lines)
 *  as depicted in the test handout. The larger oval is the sheep's body, and
 *  will get bigger as more wool grows.
 * 
 * The sheep class should contain:
 *   
 *   - Fields to store the location of the sheep, and the size of the sheep's wool.
 *       - The location specifies the centre of the sheep's body.
 *       - The size specifies the *height* of the sheep's body, and should start set to 25.
 *       - You need to make sure that the location of the sheep does not move as its wool grows.
 *       
 *   - A constructor that initializes the fields. You are required to initialize the
 *     position of the sheep. Other fields should use default values.
 *     
 *   - The draw() method that draws the sheep at the specified location with the right size.
 *     - The sheep's legs should be drawn first, using two black lines at either end of the body.
 *     - The body should be drawn next, using an unfilled oval with the correct length and height
 *     - The head is an un-filled circle at the right end of the body.
 *     - Several variables have been defined for you to help with this.
 *   
 *   - The getSize() method that returns the size of the sheep's wool.
 *   - The shear() method that reduces the size of the wool back to it's initial value.
 *   - The grow() method that increases the size of the wool by 5.
 *   
 *   You can check that your draw() method works using the Show button
 *    
 * (b) [6 marks] Complete the testSheep method in this class that will:
 *   - create a Sheep object at (100, 400)
 *   - draw it in the graphics pane
 *   - make it grow and be sheared.
 *   
 *   Write a loop to make the sheep's wool grow 20 times. Whenever the size gets above
 *   50, it should be shorn.
 */
public class Program3{

    /** Makes and draws a sheep */
    public void showSheep(){
        UI.clearGraphics();
        Sheep s = new Sheep(300, 100);
        s.draw();
    }

    /** Makes a sheep, repeatedly grows and shears it */
    public void testSheep(){        
        Sheep s = new Sheep(100, 400);
        /*# YOUR CODE HERE */
        for(int i=0; i< 20; i++) {
            s.grow();
            if(s.getSize() >= 50) {
                s.shear();
            }
            UI.sleep(500);
            UI.clearGraphics();
            s.draw();
        }
        /*# END OF YOUR CODE */

    }
    
    /*********************************************
     * YOU CAN IGNORE EVERYTHING BELOW THIS LINE *
     *********************************************/
    public void setupGUI() {
        UI.initialise();
        UI.addButton("Show",this::showSheep);
        UI.addButton("Run", this::testSheep);
        UI.setWindowSize(500,500);
        UI.setDivider(0.0);
        UI.setLineWidth(4);
    }
    
    public static void main(String[] args) {
        new Program3().setupGUI();
    }
}
