// This program is copyright VUW.
// You may not distribute it in any way without permission.

/* Code for COMP102 - 2019T2, Mid-Term Test 2
 * Name:
 * Username:
 * ID:
 */

import ecs100.*;
import java.awt.Color;

/**
 * A very simple version of a Sheep
 */
public class Sheep{
    /**
     * Data fields to store the size and location of the sheep.
     * 
     * All sheep start with the same default size (25).
     * 
     * The sheep will get fatter when it grows, but it shouldn't move.
     */
    public static final double BODY_LENGTH = 80;
    public static final double LEG_WIDTH = 4;
    public static final double LEG_HEIGHT = 30;
    public static final double HEAD_SIZE = 20;
    /*# YOUR CODE HERE */
    private double size = 25;
    private double x;
    private double y;
    /*# END OF YOUR CODE */
    
    /**
     * Constructor for a Sheep.
     * 
     * You need to initalise the position of the sheep.
     * Any other fields should use the default values.
     */
    public Sheep(double x, double y){
        /*# YOUR CODE HERE */
        this.x = x;
        this.y = y;
        /*# END OF YOUR CODE */
        
    }
    
    /**
     * Draws the sheep on the graphics pane.
     * 
     * A sheep is an oval, with a round head and two sticks for legs.
     */
    public void draw(){
        double leftBody = x - BODY_LENGTH/2;
        double rightBody = x + BODY_LENGTH/2;
        double legTop = y;
        double legBot = y + LEG_HEIGHT;
        double headTop = y-HEAD_SIZE/2;
        /*# YOUR CODE HERE */
        UI.drawLine(leftBody, legTop, leftBody, legBot);
        UI.drawLine(rightBody, legTop, rightBody, legBot);
        UI.drawOval(leftBody, y-size/2, BODY_LENGTH, size);
        UI.drawOval(rightBody, headTop, HEAD_SIZE, HEAD_SIZE);
        /*# END OF YOUR CODE */
        
    }
    
    /**
     * Returns the size of the sheep's wool.
     * 
     * This should return the size of the sheep's wool.
     */
    public double getSize(){
        /*# YOUR CODE HERE */
        return this.size;
        /*# END OF YOUR CODE */

    }
    
    /**
     * Makes a sheep's wool grow a little;
     *  - increases the size of the sheep by 5 pixels
     */
    public void grow(){
        /*# YOUR CODE HERE */
        this.size = this.size + 5;
        /*# END OF YOUR CODE */

    }
    
    /**
     * Shears the sheep;
     *   - reduces the size of the sheep back to its initial value.
     */
    public void shear(){
        /*# YOUR CODE HERE */
        this.size = 25;
        /*# END OF YOUR CODE */

    }
}
